#include <stdio.h>
#include <string.h>
#include "video.h"
//#include "util.h"
#include "usbh_env.h"
#include "pff.h"

extern FATFS fatfs;
static int color_mode;

static void UlToStr(char *s, unsigned long bin, unsigned char n)
{
    s += n;
    *s = '\0';

    while (n--)
    {
        *--s = (((int)bin % 16)>9)?  ((int)bin % 16)+ 'A'-10 : ((int)bin % 16) + '0';
        bin /= 16;
    }
}

static void UlToStr10(char *s, unsigned long bin, unsigned char n)
{
    s += n;
    *s = '\0';

    while (n--)
    {
        *--s = ((int)bin % 10) + '0';
        bin /= 10;
    }
}
void get_bitmap_data(char *file_name)  {
#ifdef COLOR8_FMT
  unsigned char *buf;
#else
  unsigned short *buf;
#endif
  FRESULT rc;
  DIR dir;
  FILINFO fno;
  WORD bw, br;
  int i,j,pbuf;
  UINT r,g,b,a;
  un_bitmap_file_header bfh;
  un_bitmap_info_header bih;
#ifdef COLOR8_FMT
  buf = (unsigned char*)FONT_BUFFER;
#else
  buf = (unsigned short*)FONT_BUFFER;
#endif
  pbuf = 0;
  pf_mount(&fatfs);
  rc = pf_open(file_name);
  if (rc) die(rc);
  rc = pf_read(bfh.BYTE, sizeof(bfh), &br);
  if (rc) die(rc);
  rc = pf_read(bih.BYTE, sizeof(bih), &br);
  if (rc) die(rc);
  printf("loading bitmap size w,h = %d %d\n",bih.KIND.biWidth,bih.KIND.biHeight);
  for (j=0;j<bih.KIND.biHeight;j++) {
	//printf("loading bitmap size j = %d\n",j);
    for (i=0;i<bih.KIND.biWidth;i++) {
      rc = pf_read(&b, 1, &br);
      rc = pf_read(&g, 1, &br);
      rc = pf_read(&r, 1, &br);
      if (bih.KIND.biBitCount==32) rc = pf_read(&a, 1, &br);
#ifdef COLOR8_FMT
      // 233 conversion
      *(volatile unsigned char *)(FONT_BUFFER+pbuf) =  (((r>>6) & 0x1f)<<6) |(((g>>5) & 0x3f)<<3)| ((b>>5) & 0x7);
      //*(buf+pbuf) =  ((b & 0x3)<<6) |((g & 0x7)<<3)| (r & 0x7);
      pbuf++;
#else
      // 565 conversion
      *(volatile unsigned short *)(FONT_BUFFER+pbuf) =  (((r>>3) & 0x1f)<<11) |(((g>>2) & 0x3f)<<5)| ((b>>3) & 0x1f);
      pbuf+=2;
#endif
    }
  }

  printf("done\n");
  if (rc) die(rc);

}

void draw_dir() {
  FRESULT rc;			/* Result code */
  DIR dir;				/* Directory object */
  FILINFO fno;			/* File information object */
  WORD bw, br;
  char s[256];
  int i;
  int offset = 288;

  if (!uh_msd_available(0)) return;
  printf("\nOpen root directory.\n");
  rc = pf_opendir(&dir, "");
  if (rc) die(rc);
  printf("\nDirectory listing...\n");
  for (;;) {
	for (i=0;i<256;i++) s[i] = 0; // width limit
    rc = pf_readdir(&dir, &fno);	/* Read a directory item */
    if (rc || !fno.fname[0]) break;	/* Error or end of dir */
    if (fno.fattrib & AM_DIR) {
      printf("  <dir>  %s\n", fno.fname);
      draw_string(XPS,offset,"<dir>  ",0);
  	  for (i=0;i<10;i++) s[i] = fno.fname[i];
      draw_string(8*XPS,offset,s,0);
      //sprintf(s,"   <dir>  %s\n", fno.fname);
    } else {
      printf("%8d  %s\n", fno.fsize, fno.fname);
      UlToStr10(s,fno.fsize, 4);
      draw_string(XPS,offset,s,0);
  	  for (i=0;i<10;i++) s[i] = fno.fname[i];
      draw_string(8*XPS,offset,s,0);

      //sprintf(s,"%8lu  %s\n", fno.fsize, fno.fname);
    }
    offset += YPS;
  }
  if (rc) die(rc);

}

void buffer_clear_fb(unsigned int c,int bank) {
  unsigned int i;
  unsigned int a,ae;
  if (bank==1) a = FB1_ADRS;
  else a = FB0_ADRS;
  ae = a+0x96000;
  if (color_mode == 2) ae = a+0x4b000;
  else if (color_mode == 3) ae = a+0x25800;
  for (i = a; i < ae; i += 4 ) {
    (*(volatile unsigned int  *)i) = c;
  }
}


void buffer_clear_fb_bk(int sy, int es,int xoffset,unsigned int c,int bank) {
  int i;
  unsigned int sa,ea;
  int xo;
  //sy : start y position
  //es : fill y size
  //xoffset : x pixel position offset, should be 32bit aligned
  if (bank==1) sa = FB1_ADRS;
  else sa = FB0_ADRS;

  if (color_mode ==2 ) {
    sa = sa + sy * SCREEN_W;
    ea = sa + es * SCREEN_W;
  } else if (color_mode ==3 ) {
      sa = sa + sy * SCREEN_W/2;
      ea = sa + es * SCREEN_W/2;
  } else {
    sa = sa + sy * SCREEN_W * 2;
    ea = sa + es * SCREEN_W * 2;
  }
  xo=0;
  for (i = sa; i < ea; i += 4 ) {
    if (xo> xoffset)
	  (*(volatile unsigned int  *)i) = c;  // 2 pixel colors
    if (color_mode == 2) xo += 4;
    else if (color_mode == 3) xo += 8;
    else xo += 2;
    if (xo >= SCREEN_W) {
      xo = 0;
    }
  }
}


#ifdef COLOR8_FMT
void draw_splite(int x, int y, int offset,unsigned char *sp,int rev) {
	  int i,j;
	  unsigned int wd;
	  int p,a;

	  for (i=0;i<16;i++) {
	    // V
	    for (j=0;j<16;j+=4) { // per 4 pixels
	  	  p = (y+i) * 640 + (x+j);  // linear pixel position

	      // H
	  	  if (fb_front==1) {
            a = FB1_ADRS + p;
	  	  }
	  	  else {
	  		a = FB0_ADRS + p;
	  	  }
	  	  a &= 0xfffffffc;
	  	  wd =   *(sp+offset+j+0+i*16*16) & 0xff;
	  	  wd |= (*(sp+offset+j+1+i*16*16) & 0xff) << 8;
          wd |= (*(sp+offset+j+2+i*16*16) & 0xff) << 16;
	      wd |= (*(sp+offset+j+3+i*16*16) & 0xff) << 24;
	  	  (*(volatile unsigned int *)a) = (rev == 1) ? ~wd : wd;
	  	}
	  }
}
#else

__attribute__ ((always_inline))
void put_pixel_fb(int x, int y, unsigned int c, int rev,int bank) {
  static unsigned int wd;
  int p,a;
  p = y * 640 + x;  // linear pixel position
  if (bank==1) {
	  if (color_mode == 2) a = FB1_ADRS + p;
	  else if (color_mode == 3) a = FB1_ADRS + p/2;
	  else a = FB1_ADRS + p*2;
  }
  else {
	  if (color_mode == 2) a = FB0_ADRS + p;
	  else if (color_mode == 3) a = FB0_ADRS + p/2;
	  else a = FB0_ADRS + p*2;
  }
  a &= 0xfffffffc;
  if (color_mode == 2) {
	// 565->233
    //c = (c & 0x7) | (((c >> 6)&0x7)<<3) | (((c >> 11) & 3)<<6);
    //c = (c & 0x7) | (((c >> 7)&0x7)<<3) | (((c >> 14) & 3)<<6);
	switch(p & 0x3) {
	case 0: wd = c & 0xff;
	  break;
	case 1: wd |= (c & 0xff) << 8;
	  break;
	case 2: wd |= (c & 0xff) << 16;
	  break;
	case 3: wd |= (c & 0xff) << 24;
	   (*(volatile unsigned int *)a) = (rev == 1) ? ~wd : wd;
	  break;
	}
  } else if (color_mode == 3) {
	// 565->121
    c = (c & 0x1) | (((c >> 9)&0x3)<<1) | (((c >> 15) & 1)<<3);
	switch(p & 0x7) {
	case 0: wd = c & 0xf;
	   break;
	case 1: wd |= (c & 0xf) << 4;
	   break;
	case 2: wd |= (c & 0xf) << 8;
	   break;
	case 3: wd |= (c & 0xf) << 12;
	   break;
	case 4: wd |= (c & 0xf) << 16;
	   break;
	case 5: wd |= (c & 0xf) << 20;
	   break;
	case 6: wd |= (c & 0xf) << 24;
	   break;
	case 7: wd |= (c & 0xf) << 28;
	   (*(volatile unsigned int *)a) = (rev == 1) ? ~wd : wd;
	   //printf("p = %x adr = %x\n",p,a);
	   break;
	}
  } else {
	switch(p & 0x1) {
	case 0: wd = c & 0xffff;
	  break;
	case 1: wd |= (c & 0xffff) << 16;
	   (*(volatile unsigned int *)a) = (rev == 1) ? ~wd : wd;
	  break;
	}
  }
}
void draw_splite(int x, int y, int offset,unsigned short *sp,int rev) {
	  int i,j;

	  for (i=0;i<16;i++) {
	    // V
	    for (j=0;j<16;j++) {
	      // H
	      put_pixel_fb(x+j,y+i,*(sp+offset+j+i*16*16),rev,fb_front);
	    }
	  }
}
#endif
/*

void draw_splite(int x, int y, int offset,unsigned short *sp,int rev) {
  int i;

  for (i=0;i<16;i+=4) {
    // V
      // H
      put_pixel_fb(x+0,y+i,*(sp+offset+0+i*16*16),rev,fb_front);
      put_pixel_fb(x+1,y+i,*(sp+offset+1+i*16*16),rev,fb_front);
      put_pixel_fb(x+2,y+i,*(sp+offset+2+i*16*16),rev,fb_front);
      put_pixel_fb(x+3,y+i,*(sp+offset+3+i*16*16),rev,fb_front);
      put_pixel_fb(x+4,y+i,*(sp+offset+4+i*16*16),rev,fb_front);
      put_pixel_fb(x+5,y+i,*(sp+offset+5+i*16*16),rev,fb_front);
      put_pixel_fb(x+6,y+i,*(sp+offset+6+i*16*16),rev,fb_front);
      put_pixel_fb(x+7,y+i,*(sp+offset+7+i*16*16),rev,fb_front);
      put_pixel_fb(x+8,y+i,*(sp+offset+8+i*16*16),rev,fb_front);
      put_pixel_fb(x+9,y+i,*(sp+offset+9+i*16*16),rev,fb_front);
      put_pixel_fb(x+10,y+i,*(sp+offset+10+i*16*16),rev,fb_front);
      put_pixel_fb(x+11,y+i,*(sp+offset+11+i*16*16),rev,fb_front);
      put_pixel_fb(x+12,y+i,*(sp+offset+12+i*16*16),rev,fb_front);
      put_pixel_fb(x+13,y+i,*(sp+offset+13+i*16*16),rev,fb_front);
      put_pixel_fb(x+14,y+i,*(sp+offset+14+i*16*16),rev,fb_front);
      put_pixel_fb(x+15,y+i,*(sp+offset+15+i*16*16),rev,fb_front);

      // H
      put_pixel_fb(x+0,y+i+1,*(sp+offset+0+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+1,y+i+1,*(sp+offset+1+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+2,y+i+1,*(sp+offset+2+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+3,y+i+1,*(sp+offset+3+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+4,y+i+1,*(sp+offset+4+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+5,y+i+1,*(sp+offset+5+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+6,y+i+1,*(sp+offset+6+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+7,y+i+1,*(sp+offset+7+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+8,y+i+1,*(sp+offset+8+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+9,y+i+1,*(sp+offset+9+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+10,y+i+1,*(sp+offset+10+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+11,y+i+1,*(sp+offset+11+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+12,y+i+1,*(sp+offset+12+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+13,y+i+1,*(sp+offset+13+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+14,y+i+1,*(sp+offset+14+(i+1)*16*16),rev,fb_front);
      put_pixel_fb(x+15,y+i+1,*(sp+offset+15+(i+1)*16*16),rev,fb_front);

      // H
      put_pixel_fb(x+0,y+i+2,*(sp+offset+0+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+1,y+i+2,*(sp+offset+1+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+2,y+i+2,*(sp+offset+2+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+3,y+i+2,*(sp+offset+3+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+4,y+i+2,*(sp+offset+4+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+5,y+i+2,*(sp+offset+5+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+6,y+i+2,*(sp+offset+6+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+7,y+i+2,*(sp+offset+7+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+8,y+i+2,*(sp+offset+8+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+9,y+i+2,*(sp+offset+9+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+10,y+i+2,*(sp+offset+10+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+11,y+i+2,*(sp+offset+11+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+12,y+i+2,*(sp+offset+12+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+13,y+i+2,*(sp+offset+13+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+14,y+i+2,*(sp+offset+14+(i+2)*16*16),rev,fb_front);
      put_pixel_fb(x+15,y+i+2,*(sp+offset+15+(i+2)*16*16),rev,fb_front);
      // H
      put_pixel_fb(x+0,y+i+3,*(sp+offset+0+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+1,y+i+3,*(sp+offset+1+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+2,y+i+3,*(sp+offset+2+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+3,y+i+3,*(sp+offset+3+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+4,y+i+3,*(sp+offset+4+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+5,y+i+3,*(sp+offset+5+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+6,y+i+3,*(sp+offset+6+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+7,y+i+3,*(sp+offset+7+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+8,y+i+3,*(sp+offset+8+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+9,y+i+3,*(sp+offset+9+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+10,y+i+3,*(sp+offset+10+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+11,y+i+3,*(sp+offset+11+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+12,y+i+3,*(sp+offset+12+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+13,y+i+3,*(sp+offset+13+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+14,y+i+3,*(sp+offset+14+(i+3)*16*16),rev,fb_front);
      put_pixel_fb(x+15,y+i+3,*(sp+offset+15+(i+3)*16*16),rev,fb_front);

  }
}
*/


#ifdef COLOR8_FMT
void draw_char(int x, int y, char c, unsigned char *sp,int rev) {
#else
void draw_char(int x, int y, char c, unsigned short *sp,int rev) {
#endif
  int offset;
 // ascii -> offset conversion
 if (c >= 'a' && c <= 'z') {
   offset = ((c-'a'+65)/WIDTH)*WIDTH*XPS*YPS +
             (((c-'a')%WIDTH) + 1)*XPS;
 } else
 if (c >= 'A' && c <= 'Z') {
   offset = ((c-'A'+33)/WIDTH)*WIDTH*XPS*YPS +
             (((c-'A')%WIDTH) + 1)*XPS;
 } else
 if (c >= ' ' && c <= '@') {
   offset = ((c-' ')/WIDTH)*WIDTH*XPS*YPS +
             ((c-' ')%WIDTH)*XPS;
 }
 draw_splite(x,y, offset,sp,rev);
}

void draw_string(int x, int y, char *s, int rev) {
  int i,len;
  len = strlen(s);
  for (i=0;i<len;i++) {
    draw_char(x+i*XPS, y, *(s+i), (unsigned short*)(FONT_BUFFER),rev);
  }
}


void video_init() {
  FB0_OFFSET = FB0_ADRS;
  FB1_OFFSET = FB1_ADRS;
  FRONT_BUFFER = 0;
  VIDEO_INT_MASK = 3;
  // clear screen
#ifdef COLOR8_FMT
  color_mode = 2;
#else
  color_mode = 0;
#endif

  COLOR_MODE = color_mode;
  printf("COLOR MODE %d\n",COLOR_MODE);
  // Video Start
  VIDEO_START = 0x00000001;
}

static int iflag = 0;

void video_update() {

  if (iflag < 2) {
    buffer_clear_fb(0x00000000,fb_front);
    draw_string(XPS,YPS,"****** DE0 USB host demo ******",0);
    draw_dir();  // draw both screen
  } else {

	  // clear upper half area
    buffer_clear_fb_bk(32,MOUSE_SCREEN_OFFSET_Y,0,
	    	               0x00000000,fb_front);
    // clear bottom right area
    buffer_clear_fb_bk(MOUSE_SCREEN_OFFSET_Y,SCREEN_H-MOUSE_SCREEN_OFFSET_Y,MOUSE_SCREEN_OFFSET_X,
	  	               0x00000000,fb_front);

  }
  update_usb_tree();
  update_mouse_pointer();

 }

int video_swap() {
	 VIDEO_INT_CLEAR = 0;
	  video_status = VIDEO_STATUS;
	  while (!(video_status & 0x1))  {
		  video_status = VIDEO_STATUS;
	  }
	  FRONT_BUFFER = fb_front;
	  if (fb_front == 0) fb_front = 1;
	  else fb_front = 0;

	  if (iflag < 4) iflag++;
	  return iflag;
}

extern st_usbh_env usbh_env;
extern st_hid_gamepad gamepad_data;
extern un_hid_mouse mouse_data;
extern un_hid_keyboard keyboard_data;
void update_usb_tree() {

  int offset,len,i;
  char c,s[8];
  volatile char *kb;
  kb = (volatile char *)(KEY_BUFFER);
  offset = 3*YPS+0*7*YPS;
  if (um_is_hub(usbh_env.conn[0].p_root)) {
 	draw_string(0,offset+YPS,"  HUB Status Change Bitmap: ",0);
	UlToStr(s,usbh_env.hub_status , 2);
	draw_string(30*XPS,offset+YPS,s,0);
    for (i=1;i<=usbh_env.conn[0].p_root->descs.hub.BYTE.bNbrPorts;i++) {

      draw_string(0,offset+(i+1)*YPS,"  Port ",0);
      UlToStr(s,i, 2);
      draw_string(8*XPS,offset+(i+1)*YPS,s,0);
      if ((usbh_env.conn[0].p_root->p_devices[i] != NULL)&&
    		  usbh_env.conn[0].p_root->p_devices[i]->info.available) {
    	if (um_is_hub(usbh_env.conn[0].p_root->p_devices[i])) {
     	  draw_string(10*XPS,offset+(i+1)*YPS,": HUB",0);
    	} else if (usbh_env.conn[0].p_root->p_devices[i]->descs.interface[0].BYTE.bInterfaceClass == UCC_MASS_STRAGE) {
       	  draw_string(10*XPS,offset+(i+1)*YPS,": Mass Storage Device",0);
    	} else {
          switch(usbh_env.conn[0].p_root->p_devices[i]->descs.interface[0].BYTE.bInterfaceProtocol) {
          default:
      	    draw_string(10*XPS,offset+(i+1)*YPS,": not available    ",0);
          break;
          case 0:
          	    draw_string(10*XPS,offset+(i+1)*YPS,": Game Pad X,Y,B=",0);
            	UlToStr(s,gamepad_data.BYTE.x, 2);
            	draw_string(27*XPS,offset+(i+1)*YPS,s,0);
            	UlToStr(s,gamepad_data.BYTE.y, 2);
            	draw_string(30*XPS,offset+(i+1)*YPS,s,0);
            	UlToStr(s,gamepad_data.BYTE.b0.BYTE, 2);
            	draw_string(33*XPS,offset+(i+1)*YPS,s,0);
            	UlToStr(s,gamepad_data.BYTE.b1.BYTE, 2);
            	draw_string(36*XPS,offset+(i+1)*YPS,s,0);
          break;
          case 1:
            //c = get_ascii_code(&usbh_env.keyboard_data);
        	len = strlen(kb);
        	if (keyboard_data.BYTE.keycode[0] == 0x7f) {
              draw_string((21+len)*XPS,offset+(i+1)*YPS," ",0);
        	}
            //sprintf(s,"  Port %d: Keyboard %s",i, keyboard_buffer);
          	draw_string(10*XPS,offset+(i+1)*YPS,": Keyboard",0);
            draw_string(21*XPS,offset+(i+1)*YPS,kb,0);
            break;
		  case 2:
        	draw_string(10*XPS,offset+(i+1)*YPS,": Mouse X, Y, B =",0);
        	UlToStr(s,mouse_data.BYTE.x, 2);
        	draw_string(30*XPS,offset+(i+1)*YPS,s,0);
        	UlToStr(s,mouse_data.BYTE.y, 2);
        	draw_string(33*XPS,offset+(i+1)*YPS,s,0);
        	UlToStr(s,mouse_data.BYTE.b, 2);
        	draw_string(36*XPS,offset+(i+1)*YPS,s,0);
            break;
          }
    	}
		} else {
         //sprintf(s,"  Port %d: not available                 ",i);
         draw_string(10*XPS,offset+(i+1)*YPS,": not available",0);
		}
      }
    }
}

void update_mouse_pointer() {
  int x,y,rev;
  static float px = 0.0;
  static float py = 0.0;
  // clear current
  x = get_mouse_x(px);
  y = get_mouse_y(py);

  if ((char)mouse_data.BYTE.x < 0) px -= MOUSE_MOVE_DELTA;
  else if ((char)mouse_data.BYTE.x > 0) px += MOUSE_MOVE_DELTA;
  if ((char)mouse_data.BYTE.y < 0) py -= MOUSE_MOVE_DELTA;
  else if ((char)mouse_data.BYTE.y > 0) py += MOUSE_MOVE_DELTA;
  if (px < -1.0) px = -1.0;
  if (px >  1.0) px =  1.0;
  if (py < -1.0) py = -1.0;
  if (py >  1.0) py =  1.0;

  if ((char)mouse_data.BYTE.b != 0) {
    //printf("mouse button pushed\n");
	rev = 1;
  }
  else rev = 0;
  // clear current
  x = get_mouse_x(px);
  y = get_mouse_y(py);
  draw_char(x, y,'o', (unsigned short*)(FONT_BUFFER),rev);

  mouse_data.BYTE.x = 0;
  mouse_data.BYTE.y = 0;
}

int get_mouse_x(float px) {
  return (int)(((px+1.0)/2.0)*(float)MOUSE_SCREEN_WIDTH) + MOUSE_SCREEN_OFFSET_X;
}
int get_mouse_y(float py){
  return (int)(((py+1.0)/2.0)*(float)MOUSE_SCREEN_HEIGHT) + MOUSE_SCREEN_OFFSET_Y;
}
